/*
 * $Id: ListUtils.js,v 1.14 2005/01/31 08:55:30 shanmugampl Exp $
 */

/**
 * Moves a selected value in the list to the top by one index.  
 * @param	the required select object in the form.
 */
function moveUp(SHOW_LIST)
{
	var temptext = SHOW_LIST.options[0].text; 
	var tempvalue = SHOW_LIST.options[0].value;

	var i=1 ,opt,canmove="false",j=0;
	while(opt = SHOW_LIST.options[i])
	{
		if (opt.selected)
		{
			j=i-1;
			while(j>=0)
			{
				if(!SHOW_LIST.options[j].selected)
				{
					canmove="true";
					break;
				}
				j--;
			}
			if(canmove == "true")
			{
				SHOW_LIST.options[i-1].value = SHOW_LIST.options[i].value;
				SHOW_LIST.options[i-1].text = SHOW_LIST.options[i].text;
				SHOW_LIST.options[i].value = tempvalue;
				SHOW_LIST.options[i].text = temptext;
				SHOW_LIST.options[i-1].selected = true;
				SHOW_LIST.options[i].selected = false;
			}
		}
		temptext = SHOW_LIST.options[i].text;
		tempvalue = SHOW_LIST.options[i++].value;
		canmove="false";
	}
	return false;
}

/**
 * Moves a selected value in the list to the bottom by one index.  
 * @param	the required select object in the form.
 */

function moveDown(SHOW_LIST)
{
    var temptext = SHOW_LIST.options[SHOW_LIST.options.length-1].text; 
    var tempvalue = SHOW_LIST.options[SHOW_LIST.options.length-1].value;
    var i=SHOW_LIST.options.length-2 ,opt,j,canmove="false";

    while(opt = SHOW_LIST.options[i])
    {
        if (opt.selected)
        {
            j=i+1;
            while(j<=SHOW_LIST.options.length-1)
            {
                if(!SHOW_LIST.options[j].selected)
                {
                    canmove="true";
                    break;
                }
                j++;
            }
            if(canmove == "true")
            {
                SHOW_LIST.options[i+1].value = SHOW_LIST.options[i].value;
                SHOW_LIST.options[i+1].text = SHOW_LIST.options[i].text;
                SHOW_LIST.options[i].value = tempvalue;
                SHOW_LIST.options[i].text = temptext;
                SHOW_LIST.options[i+1].selected = true;
                SHOW_LIST.options[i].selected = false;
            }
        }
        temptext = SHOW_LIST.options[i].text;
        tempvalue = SHOW_LIST.options[i--].value;
		canmove="false";
		if(i < 0){
			break;
		}
    }
	   return false;
}

/*
 * Moves the selected values of a source list to a destination list.
 *
 * @param	sourceList	the list whose selected values are to be moved.
 * @param	destList 	the list where the selected values are to be added.
 */
function updateLists(sourceList,destList)
{
	var opt,i=0;
	while(opt = sourceList.options[i++] )
	{
		if(opt.selected &&(opt.index >=0))
		{
			destList.options[destList.options.length] = new Option(opt.text, opt.value, true, false);
			sourceList.options[i-1] = null;
			i--;
		}
	}
	return false;
}

/*
 * Moves all the values from the source list to the destination list.
 *
 * @param	sourceList	the list whose values are to be moved.
 * @param	destList	the list where the values are to be moved.
 */
function moveAll(sourceList, destList)
{
	var opt,i=0;
	while(opt = sourceList.options[i])
	{
		destList.options[destList.options.length] = new Option(opt.text, opt.value, true, false);
		sourceList.options[i]=null;
	}
	return false;
}

/**
 * Sets all the values of the given '<select>' element to true.
 */
function selectAllFromList(selectElement){
  for(i = 0; i < selectElement.options.length; i++)
  {
	selectElement.options[i].selected = true;
  }
}
